#!/bin/bash

pushd src/java/org/fife/ui/rsyntaxtextarea/modes/ > /dev/null


editedFlex=0;
unchangedFlex=0;

flex_jar=$GEXTRSYNTAX/lib/JFlex.jar

if [ "x$GSDLOS" = "xcygwin" ] ; then
  flex_jar=`cygpath -w $flex_jar | sed 's/\\\\/\\\\\\\\/g'`
elif [ "x$GSDLOS" = "xmingw" ] ; then
  flex_jar=`echo $flex_jar | sed 's/^\/\(.\)/\1:/' | sed 's@/@\\\\@g'`
fi


for f in *.flex ; do
#  echo "Checking $f ..."
  j="${f%.*}.java"
  if [ "$f" -nt "$j" ] ; then
    echo ""
    echo "****"
    echo "* Regenerating $f"
    echo "****"
    echo ""

    java -cp "$flex_jar" JFlex.Main $f
    #bash -x jflex $f

    cat $j \
      | sed 's/public final void yyreset/public final void YYRESETOLD/g' \
      | sed 's/YYRESETNEW/yyreset/g' \
      | sed 's/private boolean zzRefill/private boolean ZZREFILLOLD/g' \
      | sed 's/ZZREFILLNEW/zzRefill/g' \
      > $j.new    

    /bin/mv $j.new $j
    ((editedFlex +=1))

  else 
#    echo "... does not need to be regenerated"
    ((unchangedFlex +=1))
  fi


done

echo "===="
echo "$unchangedFlex Flex files unchanged"
echo ""

if [ $editedFlex -ge "1" ] ; then
  echo ""
  echo "****"
  echo "* $editedFlex flex file(s) regenerated."
  echo "* Use ./COMPILE.sh to recompile the modified code and regenerate the jar file"
  echo "****"
  echo ""
fi

popd > /dev/null

